type Falsy = false | 0 | 0n | "" | null | undefined | void;
type Digit = "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9";
type Uppercase = "A" | "B" | "C" | "D" | "E" | "F" | "G" | "H" | "I" | "J" | "K" | "L" | "M" | "N" | "O" | "P" | "Q" | "R" | "S" | "T" | "U" | "V" | "W" | "X" | "Y" | "Z";
type Lowercase = "a" | "b" | "c" | "d" | "e" | "f" | "g" | "h" | "i" | "j" | "k" | "l" | "m" | "n" | "o" | "p" | "q" | "r" | "s" | "t" | "u" | "v" | "w" | "x" | "y" | "z";
type Char = "_" | Digit | Uppercase | Lowercase;
type MacroFn = (arg: any) => CSSObject;
type TokenFn = (value: string, key: string) => string | Falsy;
type Callback = () => void;
type TickFn = (callback: Callback) => unknown;
type FlushFn = (textContent: string) => string | void;
type FilterFn = (hash: string, obj: CSSObject) => boolean;
type FilterGenerator = () => FilterFn;
export type GlobalMacro = {
    [K: `$$${Char}${string}`]: MacroFn;
    [K: `$${Char}${string}`]: string | number;
    $$?: TokenFn;
};
export type CSSObject = {
    [K: string]: any;
    [K: `@${string}` | `${string}&${string}`]: CSSObject;
    [K: `$$${Char}${string}`]: MacroFn;
    [K: `$${Char}${string}`]: string | number;
    $$?: TokenFn;
};
declare const $$css: (globalMacros?: GlobalMacro | GlobalMacro[], { root, tick, flush, filter, }?: {
    root?: string | undefined;
    tick?: TickFn | undefined;
    flush?: FlushFn | undefined;
    filter?: FilterGenerator | undefined;
}) => {
    $css: (obj: CSSObject, className: string) => string;
    css: (obj: CSSObject, className?: string) => string;
};
export default $$css;
